program Borrower
begin
   { input parameters }

   { original value }
   ok,value:=InputQuery(
      'Borrower calculator',
      'Original value (in dolars)',
      '' );
   if ok=0 then exit;
   value:=StrToFloat(value);

   { date of borrow }
   ok,dt:=InputQuery(
      'Borrower calculator',
      'Date of borrowing',
      DateToStr(Date()) );
   if ok=0 then exit;
   dt:=StrToDate(dt);

   { borrow interest }
   ok,interest:=InputQuery(
      'Borrower calculator',
      'Interest (in % by month)',
      '5' );
   if ok=0 then exit;
   interest:=StrToFloat(interest);

   { borrow deadline }
   ok,deadline:=InputQuery(
      'Borrower calculator',
      'DeadLine (in days)',
      '30' );
   if ok=0 then exit;
   deadline:=StrToInt(deadline);

   { borrow forfeit }
   ok,forfeit:=InputQuery(
      'Borrower calculator',
      'Forfeit (in %)',
      '10' );
   if ok=0 then exit;
   forfeit:=StrToFloat(forfeit);

   if Validation(dt,deadline) then
   begin
      { calculation }
      present_value := CalculateBorrow(value,dt,interest,deadline,forfeit);
   
      { presentation }
      ShowMessage( 'The borrowing present value is $'+
         FormatFloat('#,###,##0.00',present_value) );
   end;
end;

routine Validation
begin
   get dt, deadline;

   { deadline validation }
   if deadline<1 then 
   begin
      ShowMessage('Deadline is invalid');
      ok:=0;
   end
   else
   begin
      ok:=1;

      { expired deadline warning }
      if date()>dt+deadline then
         ShowMessage('Borrowing has been expired on '+
            DateToStr(dt+deadline) );

      if date()=dt+deadline then
         ShowMessage('Today is the borrowing deadline');
   end;

   return ok;
end;

routine CalculateBorrow
begin
   get value,dt,interest,deadline;

   { calculate the present value of borrowing }
   present_value := value*((100+interest)/100)^((date()-dt)/30);

   get forfeit;
   if date()>dt+deadline then 
      present_value := present_value+value*forfeit/100;

   return present_value;
end;