// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'atParser.pas' rev: 3.00

#ifndef atParserHPP
#define atParserHPP
#include <ComCtrls.hpp>
#include <Dialogs.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Atparser
{
//-- type declarations -------------------------------------------------------
enum TSyntaxResult { srNotDefined, srCorrect, srIncomplete, srOverFlow, srIncorrect };

class DELPHICLASS EParserError;
class PASCALIMPLEMENTATION EParserError : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ __fastcall EParserError(const System::AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EParserError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EParserError(int Ident, Extended Dummy) : Sysutils::Exception(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EParserError(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EParserError(const System::AnsiString Msg, int AHelpContext) : 
		Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EParserError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EParserError(int Ident, int AHelpContext) : Sysutils::Exception(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EParserError(int Ident, const System::TVarRec * Args, const 
		int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EParserError(void) { }
	
};

class DELPHICLASS TNoTerminalNode;
typedef void __fastcall (__closure *TNodeScanProc)(TNoTerminalNode* Node);

typedef System::AnsiString __fastcall (__closure *TNodeStringChangeProc)(TNoTerminalNode* Node);

typedef bool __fastcall (__closure *TAcceptNodeProc)(TNoTerminalNode* Node);

struct TParsingResults
{
	TSyntaxResult Result;
	char Suggestion;
	int InputPos;
	int SyntaxPos;
	int NoTerminalIndex;
	int MaxInputPos;
	TSyntaxResult LastResult;
} ;

struct TParserDetailResults
{
	int NoTerminalIndex;
	int MaxInputPos;
	TSyntaxResult LastResult;
} ;

class DELPHICLASS TNoTerminal;
class DELPHICLASS TNoTerminals;
class PASCALIMPLEMENTATION TNoTerminal : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	System::AnsiString FIdS;
	System::AnsiString FSyntax;
	System::AnsiString FSyntaxText;
	TNodeScanProc FOnBeforeNodeScan;
	TNodeScanProc FOnAfterNodeScan;
	TAcceptNodeProc FOnAcceptNode;
	TNodeStringChangeProc FOnNodeStringChange;
	bool FReverseScanning;
	TNoTerminals* __fastcall GetNoTerminals(void);
	
public:
	void __fastcall AssignNodeScanningEvents(TNodeScanProc AOnBeforeNodeScan, TNodeScanProc AOnAfterNodeScan
		);
	__property System::AnsiString IdS = {read=FIdS, write=FIdS};
	__property System::AnsiString Syntax = {read=FSyntax, write=FSyntax};
	__property System::AnsiString SyntaxText = {read=FSyntaxText, write=FSyntaxText};
	__property TNodeScanProc OnBeforeNodeScan = {read=FOnBeforeNodeScan, write=FOnBeforeNodeScan};
	__property TNodeScanProc OnAfterNodeScan = {read=FOnAfterNodeScan, write=FOnAfterNodeScan};
	__property bool ReverseScanning = {read=FReverseScanning, write=FReverseScanning, nodefault};
	__property TAcceptNodeProc OnAcceptNode = {read=FOnAcceptNode, write=FOnAcceptNode};
	__property TNodeStringChangeProc OnNodeStringChange = {read=FOnNodeStringChange, write=FOnNodeStringChange
		};
	__property TNoTerminals* NoTerminals = {read=GetNoTerminals};
public:
	/* TCollectionItem.Create */ __fastcall virtual TNoTerminal(Classes::TCollection* Collection) : Classes::
		TCollectionItem(Collection) { }
	/* TCollectionItem.Destroy */ __fastcall virtual ~TNoTerminal(void) { }
	
};

class PASCALIMPLEMENTATION TNoTerminals : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	HIDESBASE TNoTerminal* __fastcall GetItem(int Index);
	
public:
	__fastcall TNoTerminals(void);
	HIDESBASE TNoTerminal* __fastcall Add(System::AnsiString AIdS, System::AnsiString ASyntax);
	void __fastcall Delete(int i);
	int __fastcall IndexOf(System::AnsiString IdS);
	void __fastcall LoadFromStrings(Classes::TStrings* List);
	__property TNoTerminal* Items[int Index] = {read=GetItem/*, default*/};
public:
	/* TCollection.Destroy */ __fastcall virtual ~TNoTerminals(void) { }
	
};

class DELPHICLASS TNoTerminalNodes;
class PASCALIMPLEMENTATION TNoTerminalNodes : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	TNoTerminalNode* FNode;
	HIDESBASE TNoTerminalNode* __fastcall GetItem(int i);
	
public:
	__fastcall TNoTerminalNodes(TNoTerminalNode* Owner);
	HIDESBASE TNoTerminalNode* __fastcall Add(int NoTermIndex);
	void __fastcall Delete(int i);
	int __fastcall IndexOf(int NoTerminalIndex);
	TNoTerminalNode* __fastcall FindByNoTerminalName(const System::AnsiString AName);
	__property TNoTerminalNode* Node = {read=FNode, write=FNode};
	__property TNoTerminalNode* Items[int i] = {read=GetItem/*, default*/};
public:
	/* TCollection.Destroy */ __fastcall virtual ~TNoTerminalNodes(void) { }
	
};

class DELPHICLASS TatSyntaxParser;
class DELPHICLASS TSyntaxComments;
class DELPHICLASS TSyntaxComment;
class PASCALIMPLEMENTATION TSyntaxComments : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	HIDESBASE TSyntaxComment* __fastcall GetItem(int Index);
	
public:
	HIDESBASE TSyntaxComment* __fastcall Add(System::AnsiString AOpenString, System::AnsiString ACloseString
		);
	__property TSyntaxComment* Items[int Index] = {read=GetItem/*, default*/};
public:
	/* TCollection.Create */ __fastcall TSyntaxComments(System::TMetaClass* ItemClass) : Classes::TCollection(
		ItemClass) { }
	/* TCollection.Destroy */ __fastcall virtual ~TSyntaxComments(void) { }
	
};

class PASCALIMPLEMENTATION TatSyntaxParser : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	int FBranchCount;
	TNoTerminalNode* FNode;
	TNoTerminals* FNoTerminals;
	System::AnsiString FSyntax;
	Classes::TStrings* FGrammar;
	System::AnsiString FInput;
	Classes::TStrings* FStrings;
	TParserDetailResults FParserDetailResults;
	int FScanningInputPos;
	TSyntaxComments* FComments;
	bool FDisableBranching;
	void __fastcall SetGrammar(Classes::TStrings* Value);
	void __fastcall SetStrings(Classes::TStrings* Value);
	TParsingResults __fastcall Parsing(TNoTerminalNodes* Nodes, System::AnsiString Syntax, int InputPosition
		, bool literal, int CurrentNoTerm);
	void __fastcall GrammarChange(System::TObject* Sender);
	void __fastcall StringsChange(System::TObject* Sender);
	void __fastcall SetDisableBranching(const bool Value);
	
protected:
	void __fastcall ChangePositions(TNoTerminalNode* refnode, int delta, bool ignoresubnodes);
	__property System::AnsiString Syntax = {read=FSyntax};
	
public:
	__fastcall virtual TatSyntaxParser(Classes::TComponent* AOwner);
	__fastcall virtual ~TatSyntaxParser(void);
	void __fastcall Clear(void);
	TParsingResults __fastcall CheckLanguage();
	TParsingResults __fastcall CheckExpression();
	void __fastcall BuildSyntaxTreeView(Comctrls::TTreeView* TreeView);
	void __fastcall ScanNode(TNoTerminalNode* ANode);
	bool __fastcall ScanSyntaxTree(void);
	System::AnsiString __fastcall RebuildFromNodes();
	TNoTerminalNode* __fastcall FindNodeByPosition(int p);
	__property int Effort = {read=FBranchCount, nodefault};
	__property TNoTerminals* NoTerminals = {read=FNoTerminals};
	__property TNoTerminalNode* Node = {read=FNode};
	__property Classes::TStrings* Grammar = {read=FGrammar, write=SetGrammar};
	__property Classes::TStrings* Strings = {read=FStrings, write=SetStrings};
	__property int ScanningInputPos = {read=FScanningInputPos, nodefault};
	__property System::AnsiString Input = {read=FInput};
	__property bool DisableBranching = {read=FDisableBranching, write=SetDisableBranching, nodefault};
	__property TSyntaxComments* Comments = {read=FComments};
};

class PASCALIMPLEMENTATION TNoTerminalNode : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	int FNoTerminalIndex;
	int FInputInitialPos;
	int FInputFinalPos;
	TNoTerminalNodes* FNodes;
	TatSyntaxParser* FatSyntaxParser;
	System::AnsiString __fastcall GetInputToken();
	TNoTerminalNodes* __fastcall GetOwnerNodes(void);
	TNoTerminal* __fastcall GetNoTerminal(void);
	TNoTerminalNode* __fastcall GetParentNode(void);
	char __fastcall GetInputChar(int i);
	void __fastcall CheckBoundaries(int i, int f);
	TNoTerminalNode* __fastcall ShiftSubsequentNode(int p, int delta);
	void __fastcall CheckInsertBoundaries(int i);
	int __fastcall GetFinalPos(void);
	int __fastcall GetInitialPos(void);
	int __fastcall GetTokenLength(void);
	void __fastcall SetFinalPos(const int Value);
	void __fastcall SetInitialPos(const int Value);
	void __fastcall SetTokenLength(const int Value);
	TNoTerminalNode* __fastcall GetItem(int i);
	void __fastcall MoveByOffset(int delta);
	
public:
	__fastcall virtual TNoTerminalNode(Classes::TCollection* ACollection);
	__fastcall virtual ~TNoTerminalNode(void);
	void __fastcall ChangeNodeString(System::AnsiString s);
	void __fastcall ChangeSubString(System::AnsiString s, int i, int f);
	void __fastcall FindAndReplaceSubString(System::AnsiString s, System::AnsiString s1);
	TNoTerminalNode* __fastcall InsertSubNodeString(System::AnsiString s, int p, int noterm);
	void __fastcall InsertPrefixSubString(System::AnsiString s);
	void __fastcall InsertSufixSubString(System::AnsiString s);
	void __fastcall InsertSubString(System::AnsiString s, int p);
	void __fastcall DeleteSubNode(int i);
	void __fastcall DeletePrefixSubstring(int n);
	void __fastcall DeleteSufixSubString(int n);
	void __fastcall MoveToPosition(TNoTerminalNode* refnode, int p);
	__property TNoTerminalNodes* OwnerNodes = {read=GetOwnerNodes};
	__property TNoTerminalNode* ParentNode = {read=GetParentNode};
	__property int NoTerminalIndex = {read=FNoTerminalIndex, write=FNoTerminalIndex, nodefault};
	__property int InputInitialPos = {read=FInputInitialPos, write=FInputInitialPos, nodefault};
	__property int InputFinalPos = {read=FInputFinalPos, write=FInputFinalPos, nodefault};
	__property TNoTerminalNodes* Nodes = {read=FNodes, write=FNodes};
	__property System::AnsiString InputToken = {read=GetInputToken};
	__property TatSyntaxParser* atSyntaxParser = {read=FatSyntaxParser};
	__property TNoTerminal* NoTerminal = {read=GetNoTerminal};
	__property char InputChar[int i] = {read=GetInputChar};
	__property int InitialPos = {read=GetInitialPos, write=SetInitialPos, nodefault};
	__property int FinalPos = {read=GetFinalPos, write=SetFinalPos, nodefault};
	__property int TokenLenght = {read=GetTokenLength, write=SetTokenLength, nodefault};
	__property TNoTerminalNode* Items[int i] = {read=GetItem/*, default*/};
};

class PASCALIMPLEMENTATION TSyntaxComment : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	System::AnsiString FOpenString;
	System::AnsiString FCloseString;
	
public:
	__property System::AnsiString OpenString = {read=FOpenString, write=FOpenString};
	__property System::AnsiString CloseString = {read=FCloseString, write=FCloseString};
public:
	/* TCollectionItem.Create */ __fastcall virtual TSyntaxComment(Classes::TCollection* Collection) : 
		Classes::TCollectionItem(Collection) { }
	/* TCollectionItem.Destroy */ __fastcall virtual ~TSyntaxComment(void) { }
	
};

//-- var, const, procedure ---------------------------------------------------
extern PACKAGE void __fastcall GetRowColFromStrings(Classes::TStrings* lines, int position, int &row
	, int &col);

}	/* namespace Atparser */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Atparser;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// atParser
